use std::{collections::HashMap, convert::TryFrom};

use serde::Deserialize;

use crate::error::{DittoError, ErrorKind};

#[derive(Debug, Clone, Deserialize)]
#[serde(try_from = "DittoAttachmentTokenStoredFormat")]
/// Serves as a token for a specific attachment that you can pass to a call to
/// [`fetch_attachment`](crate::store::collection::Collection::fetch_attachment).
pub struct DittoAttachmentToken {
    pub(crate) id: Box<[u8]>,
    pub(crate) len: u64,
    pub(crate) metadata: HashMap<String, String>,
}

impl TryFrom<DittoAttachmentTokenStoredFormat> for DittoAttachmentToken {
    type Error = DittoError;

    fn try_from(value: DittoAttachmentTokenStoredFormat) -> Result<Self, Self::Error> {
        if value._type != (::ffi_sdk::DittoCrdtType::Attachment as u64) {
            return Err(ErrorKind::Internal.into());
        }
        let ret = DittoAttachmentToken {
            id: value._id,
            len: value._len,
            metadata: value._meta,
        };
        Ok(ret)
    }
}

// Helper struct to help deserialize. This is to let us use
// #[derive(Deserialize)] instead of manually implementing it.
// See `impl serde::Serialize for DittoAttachment`
#[derive(Deserialize)]
struct DittoAttachmentTokenStoredFormat {
    /// FIXME(Daniel): we have to use `alias` instead of `rename` so as to avoid
    /// breakage with older Rust SDK versions using `_type` as the key name.
    #[serde(alias = "_ditto_internal_type_jkb12973t4b")]
    _type: u64,
    #[serde(with = "serde_bytes")]
    _id: Box<[u8]>,
    _len: u64,
    _meta: HashMap<String, String>,
}
